#region Using directives

using System;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter
{
    /// <summary>
    /// f𑊌ݕϊ邽߂̃Ro[^ۃNX񋟂܂
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public abstract class AbstractPropertyConverter : IPropertyConverter
    {
        #region IPropertyConverter member  

        #region events

        public event ConvertEventHandler PrepareConvert;
        public event ConvertEventHandler ConvertCompleted;
        public event ConvertEventHandler ConvertFail;

        #endregion

        public void Convert(string propertyName, object source, ref object dest, Type expectType)
        {
            if (PrepareConvert != null)
            {
                PrepareConvert(this
                 , new ConvertEventHandlerArgs(propertyName, source, ref dest, expectType));
            }

            if ( this.DoConvert(source, ref dest, expectType) )
            {
                //Ro[g
                if (ConvertCompleted != null)
                {
                    ConvertCompleted(this
                     , new ConvertEventHandlerArgs(propertyName, source, ref dest, expectType));
                }
            }
            else
            {
                Debug.WriteLine("### Property Conversion fail!");
                Debug.WriteLine("         property PropertyConverter:" + this.GetType().Name);
                Debug.WriteLine("         property Name     :" + propertyName);
                Debug.WriteLine("             source Type   :" + ((source != null) 
                                                                    ? source.GetType().Name
                                                                    :"null"));
                Debug.WriteLine("             source Value  :" + ((source != null) 
                                                                    ? source.ToString() 
                                                                    : "null"));
                Debug.WriteLine("            expected Type  :" + expectType.Name);
                //Ro[gs
                if (ConvertFail != null)
                {
                    ConvertFail(this
                     , new ConvertEventHandlerArgs(propertyName, source, ref dest, expectType));
                }
            }
        }
        
        #endregion
        #region protected methods ( for override )

        /// <summary>
        /// IuWFNg̃vpeBCӂ̌^ɕϊ܂
        /// (ۃ\bh͔hNXŕKI[oCh܂)
        /// </summary>
        /// <param name="source">ϊ̃IuWFNgZbg</param>
        /// <param name="dest">ϊ̃IuWFNgZbg</param>
        /// <param name="expectType">ϊ̃IuWFNgɊ҂Ă^Zbg</param>
        /// <returns>bool ϊꍇɂtrueԂ܂</returns>
        protected abstract bool DoConvert(object source, ref object dest, Type expectType);
        
        #endregion
    }
}