﻿#region Using directives

using System;
using System.Text;

#endregion

namespace Framework.DxO.Converter
{
    /// <summary>
    /// DXOプロパティコンバータのコンバートイベントパラメタクラス
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    //
    public class ConvertEventHandlerArgs : EventArgs
    {
        #region fields

        private string propertyName;
        private object source;
        private object dest;
        private Type expectedType;
        
        #endregion
        #region constructors

        /// <summary>
        /// コンストラクタ
        /// </summary>
        /// <param name="propertyName">対象プロパティの名前をセットします</param>
        /// <param name="source">コンバート元のオブジェクトがセットされます</param>
        /// <param name="dest">コンバート先、上書き用のオブジェクトがセットされます</param>
        /// <param name="expectedType">コンバート先として期待されている型がセットされます</param>
        public ConvertEventHandlerArgs(string propertyName, object source, ref object dest, Type expectedType)
            : base()
        {
            this.propertyName = propertyName;
            this.source = source;
            this.dest = dest;
            this.expectedType = expectedType;
        }
        #endregion

        #region Properties

        public string PropertyName
        {
            get { return this.propertyName; }
            set { this.propertyName = value; }
        }
        public object Source
        {
            get { return this.source; }
            set { this.source = value; }
        }
        public object Destiny
        {
            get { return this.dest; }
            set { this.dest = value; }
        }
        public Type ExpectedType
        {
            get { return this.expectedType; }
            set { this.expectedType = value; }
        }

        #endregion 
        #region override super class

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(this.GetType().Name).Append(" [");
            sb.Append(" propertyName = ").Append(this.propertyName).Append(", ");
            sb.Append(" source = ").Append(this.source).Append(", ");
            sb.Append(" dest = ").Append(this.dest).Append(", ");
            sb.Append(" expectedType = ").Append(this.expectedType);
            sb.Append(" ]");
            return sb.ToString();
        }
        
        #endregion
    }
}
