#region Using directives

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using Framework.DxO.Converter.Impl;
using ImageConverter=Framework.DxO.Converter.Impl.ImageConverter;

#endregion

namespace Framework.DxO.Converter
{
    /// <summary>
    /// f𑊌ݕϊ邽߂̃Ro[^𐶐邽߂̃t@NgNX`܂
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public static class ConverterFactory
    {
        #region fields
        
        static IPropertyConverter assignableConverter = new AssignableConverter();
        static IPropertyConverter listConverter = new ListConverter();
        static IPropertyConverter dictionaryConverter = new DictionaryConverter();
        static IPropertyConverter enumConverter = new EnumConverter();
        static IPropertyConverter convertibleConverter = new ConvertibleConverter();
        static IPropertyConverter typeConverterConverter = new TypeConverterConverter();
        static IPropertyConverter imageConverter = new ImageConverter();
        
        static IDictionary<Type, IPropertyConverter> converters;
        
	    #endregion    
        #region constructors
        
        static ConverterFactory()
        {
            //Ro[^
            converters = new Dictionary<Type, IPropertyConverter>();
        }
        
        #endregion
        #region public methods

        /// <summary>
        /// K؂ȃRo[^擾܂
        /// </summary>
        /// <param name="source">Ro[^KvƂĂAIuWFNgZbg܂</param>
        /// <param name="destType">IuWFNgϊ^Zbg܂</param>
        /// <returns>IPropertyConverter K؂ȃRo[^߂܂</returns>
        public static IPropertyConverter GetConverter(object source, Type destType)
        {
            Debug.Assert(destType != null, "destType͔null̂͂");

            if ((source != null && source.GetType().Equals(destType)) // ^
                || (source != null && source.GetType().IsSubclassOf(destType))) // h^
            {
                return assignableConverter;
            }
            else if (destType.IsGenericType) //WFlbN
            {
                //^p^Ȃ^擾
                Type openType = destType.GetGenericTypeDefinition();

                //Ro[^̃I[vȌ^
                Type converterOpenType = null;
                
                //ϊWFlNX̌^p^z
                Type[] typeParams = destType.GetGenericArguments();

                //ICollection<>
                if (typeof(ICollection<>).IsAssignableFrom(openType))
                {
                    converterOpenType = typeof(GenericsCollectionConverter<>);
                }
                //IList<>
                else if (typeof(IList<>).IsAssignableFrom(openType))
                {
                    converterOpenType = typeof(GenericsListConverter<>);
                }
                //IDictionary<>
                else if (typeof(IDictionary<, >).IsAssignableFrom(openType))
                {
                    converterOpenType = typeof(GenericsDictionaryConverter<, >);
                }
                
                //WFlNXRo[^𐶐A͎擾
                return (converterOpenType != null)
                           ? GetGenericsConverter(converterOpenType, typeParams)
                           : typeConverterConverter;
            }
            else
            {
                if (destType.IsArray) //z
                {
                    Type[] typeParams = new Type[] { destType.GetElementType() };
                    //WFlNXRo[^𐶐A͎擾
                    return GetGenericsConverter(typeof(ArrayConverter<>), typeParams);
                }
                else if (typeof(IList).IsAssignableFrom(destType))//Xg
                {
                    return listConverter;
                }
                else if (typeof(IDictionary).IsAssignableFrom(destType)) //
                {
                    return dictionaryConverter;
                }
                else if (destType.IsPrimitive) //v~eBu
                {
                    return convertibleConverter;
                }
                else if (destType.IsEnum)  //񋓂
                {
                    return enumConverter;
                }
                else if (typeof(Image).IsAssignableFrom(destType)) //C[W
                {
                    return imageConverter;
                }
                else //KȂꍇTypeConvtertergĂ݂
                {
                    return typeConverterConverter;
                }
            }
        }

        #endregion
        #region private methods
  
        /// <summary>
        /// Genrricsgp^Ro[^擾܂
        /// </summary>
        /// <param name="openType">Generics̃I[v^CvZbg܂</param>
        /// <param name="typeParams">Genericš^p^Zbg܂</param>
        /// <returns>IPropertyConverter 邩A͎擾Ro[^߂܂</returns>
        private static IPropertyConverter GetGenericsConverter(Type openType, Type[] typeParams)
        {
            Type converterType = openType.MakeGenericType(typeParams);
            if (! converters.ContainsKey(converterType) )
            {
                //GenericsRNVpRo[^̃CX^X𐶐
                IPropertyConverter propertyConverter =  
                    Activator.CreateInstance(converterType) as IPropertyConverter;
                converters[converterType] = propertyConverter;
                
            }
            return converters[converterType];
        }
        
        #endregion
    }
}