#region Using directives

using System;
using System.ComponentModel;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgIConvertibleɕϊ邽߂̃Ro[^`܂
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class ConvertibleConverter : AbstractPropertyConverter
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof(IConvertible).IsAssignableFrom(expectType)
                         , "expectTypeIConvertiblê͂");

            if (source is IConvertible)
            {
                dest = System.Convert.ChangeType(source, expectType);
                return true;
            }
            else if ( source.GetType().IsEnum )
            {
                if (Enum.IsDefined(source.GetType(), source))
                {
                    dest = source;
                    return true;
                }
            }
            else
            {
                //^Ro[^擾
                TypeConverter converter = TypeDescriptor.GetConverter(expectType);

                if (converter != null)
                {
                    if (converter.CanConvertFrom(source.GetType()))
                    {
                        dest = converter.ConvertFrom(source);
                        return true;
                    }
                }
            }
            return false;
        }
    }
}