#region Using directives

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgICollection<typeparam name="T">֕ϊRo[^
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class GenericsCollectionConverter<T> : AbstractPropertyConverter
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof(ICollection<T>).IsAssignableFrom(expectType)
                         , "expectTypeICollection<" + typeof(T).Name + ">ƌ݊ȂĂ͂ȂȂ");

            if (dest == null)
            {
                if (expectType.IsClass && !expectType.IsAbstract)
                {
                    dest = Activator.CreateInstance(expectType);
                }
                else
                {
                    throw new DxOException("expectType͋ۃNXł͂Ȃ̂Ŏ̉邱ƂłȂ");
                }
            }
            ICollection<T> result = dest as ICollection<T>;
            result.Clear();

            if (source is IEnumerable)
            {
                if (source is ICollection<T>)
                {
                    foreach (T item in (source as ICollection<T>))
                    {
                        result.Add(item);
                    }
                    return true;
                }
                else if (source is IList<T>)
                {
                    //WFlbNڃRs[ł
                    foreach (T o in source as IList<T>)
                    {
                        result.Add(o);
                    }
                    return true;
                }
                else if (source.GetType().IsArray)
                {
                    //vf̌^Ɍ݊邩
                    Type elementType = source.GetType().GetElementType();
                    if (typeof(T).IsAssignableFrom(elementType))
                    {
                        foreach (object item in (T[])source)
                        {
                            result.Add((T)item);
                        }
                        return true;
                    }
                }
                else
                {
                    foreach (object item in source as IEnumerable)
                    {
                        //weWjAXȃRNV̉\̂ŁAACeɌ^`FbNKv
                        if (typeof(T).IsAssignableFrom(item.GetType()))
                        {
                            result.Add((T)item);
                        }
                        else
                        {
                            return false;
                        }
                    }
                }
                return true;
            }
            return false;
        }
    }
}