#region Using directives

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgIDictionary<typeparam name="K"><typeparam name="V">֕ϊRo[^
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class GenericsDictionaryConverter<K, V> : AbstractPropertyConverter 
        where K: class
        where V: class
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof(IDictionary<K, V>).IsAssignableFrom(expectType)
                         , string.Format("expectTypeIDictionary<{0}{1}>ƌ݊ȂĂ͂ȂȂ"
                         , typeof(K).Name, typeof(V).Name));

            if (dest == null)
            {
                if (expectType.IsClass && !expectType.IsAbstract)
                {
                    dest = Activator.CreateInstance(expectType);
                }
                else
                {
                    throw new DxOException("expectType͋ۃNXł͂Ȃ̂Ŏ̉邱ƂłȂ");
                }
            }
            IDictionary<K, V> result = dest as IDictionary<K, V>;
            result.Clear();

            if (source is IDictionary<K, V>)
            {
                foreach (KeyValuePair<K, V> pair in (source as IDictionary<K, V>))
                {
                    result.Add(pair.Key, pair.Value);
                }
                return true;
            }
            else if (source is IDictionary)
            {
                foreach ( object key in (source as IDictionary).Keys)
                {
                    object value = (source as IDictionary)[key];
                    if (typeof(K).IsAssignableFrom(key.GetType())
                    && typeof(V).IsAssignableFrom(value.GetType()))
                    {
                        result.Add((K)key, (V)value);
                    }
                    else
                    {
                        return false;
                    }
                }
                return true;
            }
            return false;
        }
    }

}