#region Using directives

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;

#endregion

namespace Framework.DxO.Converter.Impl
{
    /// <summary>
    /// IuWFNgIList<typeparam name="T">֕ϊRo[^
    /// </summary>
    /// <author>Kazz.satou</author>
    /// <version> 1.0 11/24, 2006</version>
    ///
    public class GenericsListConverter<T> : AbstractPropertyConverter 
        where T:class
    {
        protected override bool DoConvert(object source, ref object dest, Type expectType)
        {
            Debug.Assert(typeof(IList<T>).IsAssignableFrom(expectType)
                         , "expectTypeIList<" + typeof(T).Name + ">ƌ݊ȂĂ͂ȂȂ");

            if (dest == null)
            {
                if (expectType.IsClass && !expectType.IsAbstract)
                {
                    dest = Activator.CreateInstance(expectType);
                }
                else
                {
                    throw new DxOException("expectType͋ۃNXł͂Ȃ̂Ŏ̉邱ƂłȂ");
                }
            }
            IList<T> result = dest as IList<T>;
            result.Clear();

            if (source is IEnumerable)
            {
                if (source is IList<T>)
                {
                    foreach (T item in (source as IList<T>))
                    {
                        result.Add(item);
                    }
                    return true;
                }
                else if (source.GetType().IsArray)
                {
                    //vf̌^Ɍ݊邩
                    Type elementType = source.GetType().GetElementType();
                    if (typeof(T).IsAssignableFrom(elementType))
                    {
                        foreach (object item in (T[])source)
                        {
                            result.Add(item as T);
                        }
                        return true;
                    }
                }
                else
                {
                    foreach (object item in source as IEnumerable)
                    {
                        if (typeof(T).IsAssignableFrom(item.GetType()))
                        {
                            result.Add(item as T);
                        }
                        else
                        {
                            return false;
                        }
                    }
                    return true;
                }
           }
            return false;
        }
    }

}